## gvmd 26.5.0

=== CMakeLists.txt ===
# Copyright (C) 2009-2022 Greenbone AG
#
# SPDX-License-Identifier: AGPL-3.0-or-later
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.5)

message("-- Configuring Greenbone Vulnerability Manager...")

project(gvm VERSION 26.5.0 LANGUAGES C)

if(POLICY CMP0005)
  cmake_policy(SET CMP0005 NEW)
endif(POLICY CMP0005)

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

include(FindPkgConfig)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif(NOT CMAKE_BUILD_TYPE)

option(ENABLE_COVERAGE "Enable support for coverage analysis" OFF)
option(DEBUG_FUNCTION_NAMES "Print function names on entry and exit" OFF)

## Retrieve git revision (at configure time)
include(GetGit)
if(NOT CMAKE_BUILD_TYPE MATCHES "Release")
  if(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
    if(GIT_FOUND)
      git_get_revision(${CMAKE_SOURCE_DIR} ProjectRevision)
      set(GIT_REVISION "~git-${ProjectRevision}")
    else(GIT_FOUND)
      set(GIT_REVISION "~git")
    endif(GIT_FOUND)
  endif(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
endif(NOT CMAKE_BUILD_TYPE MATCHES "Release")

# Set dev version if this is a development version and not a full release,
# unset (put value 0 or delete line) before a full release and reset after.
set(PROJECT_DEV_VERSION 0)

# If PROJECT_DEV_VERSION is set, the version string will be set to:
#   "major.minor.patch~dev${PROJECT_DEV_VERSION}${GIT_REVISION}"
# If PROJECT_DEV_VERSION is NOT set, the version string will be set to:
#   "major.minor.patch${GIT_REVISION}"
# For CMAKE_BUILD_TYPE "Release" the git revision will be empty.
if(PROJECT_DEV_VERSION)
  set(PROJECT_VERSION_SUFFIX "~dev${PROJECT_DEV_VERSION}")
endif(PROJECT_DEV_VERSION)

set(
  PROJECT_VERSION_STRING
  "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}${PROJECT_VERSION_SUFFIX}${GIT_REVISION}"
)

## make format
message(STATUS "Looking for clang-format...")
find_program(CLANG_FORMAT clang-format)

if(CLANG_FORMAT)
  message(STATUS "Looking for clang-format... ${CLANG_FORMAT}")
  add_custom_target(
    format
    COMMAND
      ${CLANG_FORMAT} "-style=file" "src/gmp_{base,delete,get,tickets}.h"
      "src/{gmp,gmpd,iterator,sql,types,utils,manage_utils}.h"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
else(CLANG_FORMAT)
  message(STATUS "clang-format not found.")
endif(CLANG_FORMAT)

## CPack configuration

set(CPACK_CMAKE_GENERATOR "Unix Makefiles")
set(CPACK_GENERATOR "TGZ")
set(CPACK_INSTALL_CMAKE_PROJECTS ".;gvm;ALL;/")
set(CPACK_MODULE_PATH "")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_WELCOME "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_TOPLEVEL_TAG "")
set(CPACK_SYSTEM_NAME "")
set(CPACK_TOPLEVEL_TAG "")

set(CPACK_PACKAGE_VERSION "${PROJECT_VERSION_STRING}${PROJECT_VERSION_GIT}")

set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set(CPACK_PACKAGE_VENDOR "Greenbone AG")
set(CPACK_SOURCE_IGNORE_FILES "${CMAKE_BINARY_DIR}" "/.git/" "swp$")

include(CPack)

## Variables

set(GVMD_DATABASE_VERSION 262)

set(GVMD_SCAP_DATABASE_VERSION 22)

set(GVMD_CERT_DATABASE_VERSION 8)

if(ENABLE_AGENTS OR ENABLE_CONTAINER_SCANNING)
  # Set a to the next GMP version if unstable features are enabled
  set(GMP_VERSION "22.8")
else(ENABLE_AGENTS OR ENABLE_CONTAINER_SCANNING)
  set(GMP_VERSION "22.7")
endif(ENABLE_AGENTS OR ENABLE_CONTAINER_SCANNING)

if(SYSCONF_INSTALL_DIR)
  set(SYSCONFDIR "${SYSCONF_INSTALL_DIR}")
endif(SYSCONF_INSTALL_DIR)

if(NOT SYSCONFDIR)
  set(SYSCONFDIR "/etc")
endif(NOT SYSCONFDIR)

if(NOT EXEC_PREFIX)
  set(EXEC_PREFIX "${CMAKE_INSTALL_PREFIX}")
endif(NOT EXEC_PREFIX)

if(NOT BINDIR)
  set(BINDIR "${EXEC_PREFIX}/bin")
endif(NOT BINDIR)

if(NOT SBINDIR)
  set(SBINDIR "${EXEC_PREFIX}/sbin")
endif(NOT SBINDIR)

if(NOT LIBDIR)
  set(LIBDIR "${EXEC_PREFIX}/lib")
endif(NOT LIBDIR)

if(NOT LOCALSTATEDIR)
  set(LOCALSTATEDIR "/var")
endif(NOT LOCALSTATEDIR)

if(NOT DATADIR)
  set(DATADIR "${CMAKE_INSTALL_PREFIX}/share")
endif(NOT DATADIR)

if(NOT INCLUDEDIR)
  set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include")
endif(NOT INCLUDEDIR)

set(GVM_SYSCONF_DIR "${SYSCONFDIR}/gvm")

set(GVM_DATA_DIR "${DATADIR}/gvm")
if(NOT GVMD_DATA_DIR)
  set(GVMD_DATA_DIR "${GVM_DATA_DIR}/gvmd")
endif(NOT GVMD_DATA_DIR)

if(NOT GVM_STATE_DIR)
  set(GVM_STATE_DIR "${LOCALSTATEDIR}/lib/gvm")
else(NOT GVM_STATE_DIR)
  set(GVM_STATE_DIR "${GVM_STATE_DIR}")
endif(NOT GVM_STATE_DIR)

if(NOT GVMD_STATE_DIR)
  set(GVMD_STATE_DIR "${GVM_STATE_DIR}/gvmd")
endif(NOT GVMD_STATE_DIR)

if(NOT GVMD_LOG_FILE)
  if(GVM_LOG_DIR)
    set(GVMD_LOG_FILE "${GVM_LOG_DIR}/gvmd.log")
  else(GVM_LOG_DIR)
    set(GVMD_LOG_FILE "-")
  endif(GVM_LOG_DIR)
endif(NOT GVMD_LOG_FILE)

set(GVM_SCAP_RES_DIR "${GVM_DATA_DIR}/scap")
set(GVM_CERT_RES_DIR "${GVM_DATA_DIR}/cert")
set(GVM_CA_DIR "${GVMD_STATE_DIR}/trusted_certs")

if(NOT GVM_LIB_INSTALL_DIR)
  set(GVM_LIB_INSTALL_DIR "${LIBDIR}")
else(NOT GVM_LIB_INSTALL_DIR)
  set(GVM_LIB_INSTALL_DIR "${GVM_LIB_INSTALL_DIR}")
endif(NOT GVM_LIB_INSTALL_DIR)

set(GVM_SCANNER_CERTIFICATE "${GVM_STATE_DIR}/CA/servercert.pem")
set(GVM_SCANNER_KEY "${GVM_STATE_DIR}/private/CA/serverkey.pem")
set(GVM_CLIENT_CERTIFICATE "${GVM_STATE_DIR}/CA/clientcert.pem")
set(GVM_CLIENT_KEY "${GVM_STATE_DIR}/private/CA/clientkey.pem")
set(GVM_CA_CERTIFICATE "${GVM_STATE_DIR}/CA/cacert.pem")

if(NOT GVMD_RUN_DIR)
  set(GVMD_RUN_DIR "/run/gvmd")
endif(NOT GVMD_RUN_DIR)

if(NOT GVMD_PID_PATH)
  set(GVMD_PID_PATH "${GVMD_RUN_DIR}/gvmd.pid")
endif(NOT GVMD_PID_PATH)

if(NOT GVM_FEED_LOCK_PATH)
  set(GVM_FEED_LOCK_PATH "${GVM_STATE_DIR}/feed-update.lock")
endif(NOT GVM_FEED_LOCK_PATH)
add_definitions(-DGVM_FEED_LOCK_PATH="${GVM_FEED_LOCK_PATH}")

if(NOT OPENVAS_DEFAULT_SOCKET)
  set(OPENVAS_DEFAULT_SOCKET "/run/ospd/ospd-openvas.sock")
endif(NOT OPENVAS_DEFAULT_SOCKET)
add_definitions(-DOPENVAS_DEFAULT_SOCKET="${OPENVAS_DEFAULT_SOCKET}")

# TODO: Once we separate the RFP signatures out of "plugins" and
# into var/lib/gvm/rfpsigs/ (via a sync script) then we do not need
# to know about the NVT_DIR anymore.
if(NOT GVM_NVT_DIR)
  set(GVM_NVT_DIR "${LOCALSTATEDIR}/lib/openvas/plugins/")
endif(NOT GVM_NVT_DIR)

if(NOT DATA_OBJECTS_FEED_DIR)
  set(DATA_OBJECTS_FEED_DIR "${LOCALSTATEDIR}/lib/gvm/data-objects")
endif(NOT DATA_OBJECTS_FEED_DIR)

if(NOT GVMD_FEED_DIR)
  set(GVMD_FEED_DIR "${DATA_OBJECTS_FEED_DIR}/gvmd")
endif(NOT GVMD_FEED_DIR)

if(NOT GVM_ACCESS_KEY_DIR)
  set(GVM_ACCESS_KEY_DIR "${GVM_SYSCONF_DIR}")
endif(NOT GVM_ACCESS_KEY_DIR)

if(NOT GVM_CERT_DATA_DIR)
  set(GVM_CERT_DATA_DIR "${GVM_STATE_DIR}/cert-data")
endif(NOT GVM_CERT_DATA_DIR)

if(NOT GVM_SCAP_DATA_DIR)
  set(GVM_SCAP_DATA_DIR "${GVM_STATE_DIR}/scap-data")
endif(NOT GVM_SCAP_DATA_DIR)

# System username to use when dropping privileges
if(NOT GVM_DEFAULT_DROP_USER)
  set(GVM_DEFAULT_DROP_USER "")
endif(NOT GVM_DEFAULT_DROP_USER)

# Feature toggles
if(NOT OPENVASD)
  set(OPENVASD 0)
endif(NOT OPENVASD)
add_definitions(-DOPENVASD=${OPENVASD})

if(NOT ENABLE_AGENTS)
  set(ENABLE_AGENTS 0)
endif(NOT ENABLE_AGENTS)
add_definitions(-DENABLE_AGENTS=${ENABLE_AGENTS})

if(ENABLE_AGENTS EQUAL 1)
  set(IF_ENABLE_AGENTS "")
  set(ENDIF_ENABLE_AGENTS "")
  set(IF_NOT_ENABLE_AGENTS "<!--")
  set(ENDIF_NOT_ENABLE_AGENTS "-->")
elseif(ENABLE_AGENTS EQUAL 0)
  set(IF_ENABLE_AGENTS "<!--")
  set(ENDIF_ENABLE_AGENTS "-->")
  set(IF_NOT_ENABLE_AGENTS "")
  set(ENDIF_NOT_ENABLE_AGENTS "")
endif()

if(NOT FEED_VT_METADATA)
  set(FEED_VT_METADATA 0)
endif(NOT FEED_VT_METADATA)
add_definitions(-DFEED_VT_METADATA=${FEED_VT_METADATA})

if(NOT ENABLE_CONTAINER_SCANNING)
  set(ENABLE_CONTAINER_SCANNING 0)
endif(NOT ENABLE_CONTAINER_SCANNING)
add_definitions(-DENABLE_CONTAINER_SCANNING=${ENABLE_CONTAINER_SCANNING})

if(ENABLE_CONTAINER_SCANNING EQUAL 1)
  set(IF_ENABLE_CONTAINER_SCANNNING "")
  set(ENDIF_ENABLE_CONTAINER_SCANNNING "")
elseif(ENABLE_CONTAINER_SCANNING EQUAL 0)
  set(IF_ENABLE_CONTAINER_SCANNNING "<!--")
  set(ENDIF_ENABLE_CONTAINER_SCANNNING "-->")
endif()

# HTTP scanner capability (used by OPENVASD / AGENTS / CONTAINER_SCANNING)
if(OPENVASD OR ENABLE_AGENTS OR ENABLE_CONTAINER_SCANNING)
  set(ENABLE_HTTP_SCANNER 1)
else()
  set(ENABLE_HTTP_SCANNER 0)
endif()
add_definitions(-DENABLE_HTTP_SCANNER=${ENABLE_HTTP_SCANNER})

message("-- Install prefix: ${CMAKE_INSTALL_PREFIX}")
message("-- Log file: ${GVMD_LOG_FILE}")

## Version

set(GVMD_VERSION "${PROJECT_VERSION_STRING}")

# Configure Doxyfile with version number
configure_file(docs/Doxyfile.in docs/Doxyfile)
configure_file(docs/Doxyfile_full.in docs/Doxyfile_full)
configure_file(docs/Doxyfile_xml.in docs/Doxyfile_xml)
configure_file(
  docs/example-gvm-manage-certs.conf.in
  docs/example-gvm-manage-certs.conf
  @ONLY
)
configure_file(VERSION.in VERSION)
configure_file(src/gvmd_log_conf.cmake_in src/gvmd_log.conf)
configure_file(
  src/schema_formats/XML/GMP.xml.in
  src/schema_formats/XML/GMP.xml
  @ONLY
)
configure_file(tools/gvm-manage-certs.in tools/gvm-manage-certs @ONLY)

## Code coverage

option(ENABLE_COVERAGE "Enable support for coverage analysis" OFF)
if(ENABLE_COVERAGE)
  set(COVERAGE_FLAGS "--coverage -ftest-coverage -fprofile-arcs")
  set(COVERAGE_DIR "${CMAKE_BINARY_DIR}/coverage")
  file(MAKE_DIRECTORY ${COVERAGE_DIR})
  message("-- Code Coverage enabled")
endif(ENABLE_COVERAGE)

## Testing

enable_testing()

## Program

if(DEBUG_FUNCTION_NAMES)
  # The excluded functions are for update_nvti_cache, which fills the log
  # quickly.  Hopefully this internal NVTi cache is removed soon.
  set(
    DEBUG_FUNCTION_NAMES_FLAGS
    "-finstrument-functions -finstrument-functions-exclude-function-list=iterator_string,sql_column_text,next,sql_exec_internal"
  )
  set(LINKER_DEBUG_FLAGS "${CMAKE_DL_LIBS}")
endif(DEBUG_FUNCTION_NAMES)

set(
  HARDENING_FLAGS
  "-Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector"
)
set(LINKER_HARDENING_FLAGS "-Wl,-z,relro -Wl,-z,now")

# To find unused functions, add: -flto -fwhole-program -ffunction-sections -Wl,--gc-sections -Wl,--print-gc-sections
set(
  CMAKE_C_FLAGS
  "${CMAKE_C_FLAGS} -Wall -D_BSD_SOURCE -D_ISOC99_SOURCE -D_SVID_SOURCE -D_DEFAULT_SOURCE -D_FILE_OFFSET_BITS=64 ${COVERAGE_FLAGS}"
)

set(
  CMAKE_C_FLAGS_DEBUG
  "${CMAKE_C_FLAGS_DEBUG} -Werror -Wshadow ${COVERAGE_FLAGS} ${DEBUG_FUNCTION_NAMES_FLAGS}"
)
set(
  CMAKE_C_FLAGS_RELEASE
  "${CMAKE_C_FLAGS_RELEASE} ${HARDENING_FLAGS} ${COVERAGE_FLAGS}"
)

# Flags used only for the gvmd binary, and not for the Postgres module.
set(C_FLAGS_DEBUG_GVMD "-Wredundant-decls")

if(NOT SKIP_SRC)
  add_subdirectory(src)
endif(NOT SKIP_SRC)

## Configs (e.g. systemd service file)

add_subdirectory(config)

## Documentation

add_subdirectory(docs)

## Install

install(DIRECTORY DESTINATION ${GVMD_STATE_DIR})

install(
  FILES ${CMAKE_BINARY_DIR}/src/gvmd_log.conf
  DESTINATION ${GVM_SYSCONF_DIR}
)

install(
  FILES ${CMAKE_SOURCE_DIR}/src/pwpolicy.conf
  DESTINATION ${GVM_SYSCONF_DIR}
)

# Schema formats.

install(
  FILES src/schema_formats/rnc.xsl
  DESTINATION ${GVMD_DATA_DIR}/global_schema_formats/
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
)

install(
  FILES src/schema_formats/rnc.xsl src/schema_formats/HTML/HTML.xsl

=== config/CMakeLists.txt ===
# Copyright (C) 2020-2022 Greenbone AG
#
# SPDX-License-Identifier: AGPL-3.0-or-later
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

if(NOT SYSTEMD_SERVICE_DIR)
  set(SYSTEMD_SERVICE_DIR "${LIBDIR}/systemd/system")
endif(NOT SYSTEMD_SERVICE_DIR)

if(NOT LOGROTATE_DIR)
  set(LOGROTATE_DIR "${SYSCONFDIR}/logrotate.d")
endif(NOT LOGROTATE_DIR)

configure_file(gvmd.service.in gvmd.service)
configure_file(gvmd.logrotate.in gvmd.logrotate)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/gvmd.service
  DESTINATION ${SYSTEMD_SERVICE_DIR}/
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/gvmd.logrotate
  DESTINATION ${LOGROTATE_DIR}/
  RENAME gvmd
)

=== src/CMakeLists.txt ===
# Copyright (C) 2009-2022 Greenbone AG
#
# SPDX-License-Identifier: AGPL-3.0-or-later
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

## Libraries

find_package(Threads)

## Dependency checks
##
## TODO Also check for headers where needed.
## Improve for workflow: First collect list of missing libs, then print the
## list and throw an error, otherwise long install-cmake-install-cmake cycles
## might occur.

pkg_check_modules(CJSON REQUIRED libcjson>=1.7.14)
pkg_check_modules(LIBGVM_BASE REQUIRED libgvm_base>=22.29)
pkg_check_modules(LIBGVM_UTIL REQUIRED libgvm_util>=22.29)
pkg_check_modules(LIBGVM_OSP REQUIRED libgvm_osp>=22.29)
pkg_check_modules(LIBGVM_GMP REQUIRED libgvm_gmp>=22.29)

if(ENABLE_HTTP_SCANNER)
  pkg_check_modules(LIBGVM_HTTP REQUIRED libgvm_http>=22.29)
  pkg_check_modules(LIBGVM_HTTP_SCANNER REQUIRED libgvm_http_scanner>=22.29)
endif(ENABLE_HTTP_SCANNER)
if(OPENVASD)
  pkg_check_modules(LIBGVM_OPENVASD REQUIRED libgvm_openvasd>=22.29)
else(OPENVASD)
  message(STATUS "OPENVASD flag is not enabled")
endif(OPENVASD)
if(ENABLE_AGENTS)
  pkg_check_modules(
    LIBGVM_AGENT_CONTROLLER
    REQUIRED
    libgvm_agent_controller>=22.29
  )
else(ENABLE_AGENTS)
  message(STATUS "ENABLE_AGENTS flag is not enabled")
endif(ENABLE_AGENTS)
if(ENABLE_CONTAINER_SCANNING)
  pkg_check_modules(
    LIBGVM_CONTAINER_IMAGE_SCANNER
    REQUIRED
    libgvm_container_image_scanner>=22.29
  )
else(ENABLE_CONTAINER_SCANNING)
  message(STATUS "ENABLE_CONTAINER_SCANNING flag is not enabled")
endif(ENABLE_CONTAINER_SCANNING)
pkg_check_modules(GNUTLS REQUIRED gnutls>=3.2.15)
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.42)
pkg_check_modules(LIBBSD REQUIRED libbsd)
pkg_check_modules(LIBICAL REQUIRED libical>=1.00)
pkg_check_modules(GPGME REQUIRED gpgme)

message(STATUS "Looking for PostgreSQL...")
find_program(PG_CONFIG_EXECUTABLE pg_config DOC "pg_config")
execute_process(
  COMMAND ${PG_CONFIG_EXECUTABLE} --includedir-server
  OUTPUT_VARIABLE PostgreSQL_SERVER_INCLUDE_DIRS
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
set(PostgreSQL_ADDITIONAL_SEARCH_PATHS ${PostgreSQL_SERVER_INCLUDE_DIRS})
find_package(PostgreSQL REQUIRED)
if(NOT PostgreSQL_FOUND)
  message(SEND_ERROR "The PostgreSQL library is required.")
endif(NOT PostgreSQL_FOUND)
string(
  REGEX MATCH
  "^[ \t]*\([0-9]+\)\\.\([0-9]+\)\(.*\)"
  TEMP
  "${PostgreSQL_VERSION_STRING}"
)
if(NOT CMAKE_MATCH_1)
  message(SEND_ERROR "Error matching PostgreSQL version.")
elseif(
  (CMAKE_MATCH_1 EQUAL 9 AND CMAKE_MATCH_2 LESS 6)
  OR (CMAKE_MATCH_1 LESS 9)
)
  message(SEND_ERROR "PostgreSQL version >= 9.6 is required")
  message(
    STATUS
    "PostgreSQL version ${CMAKE_MATCH_1}.${CMAKE_MATCH_2}${CMAKE_MATCH_3}"
  )
endif(NOT CMAKE_MATCH_1)

message(STATUS "Looking for xsltproc...")
find_program(XSLTPROC_EXECUTABLE xsltproc DOC "xsltproc")
if(NOT XSLTPROC_EXECUTABLE)
  message(SEND_ERROR "The xsltproc binary is required.")
else(NOT XSLTPROC_EXECUTABLE)
  message(STATUS "Looking for xsltproc... ${XSLTPROC_EXECUTABLE}")
endif(NOT XSLTPROC_EXECUTABLE)

if(NOT GPGME_FOUND)
  # fallback for older gpgme versions without gpgme.pc file
  message(STATUS "Looking for gpgme...")
  find_library(GPGME gpgme)
  if(NOT GPGME)
    message(SEND_ERROR "The gpgme library is required.")
  else(NOT GPGME)
    message(STATUS "Looking for gpgme... ${GPGME}")
    execute_process(
      COMMAND gpgme-config --cflags
      OUTPUT_VARIABLE GPGME_CFLAGS
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    execute_process(
      COMMAND gpgme-config --libs
      OUTPUT_VARIABLE GPGME_LDFLAGS
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  endif(NOT GPGME)
endif(NOT GPGME_FOUND)

if(WITH_LIBTHEIA)
  find_package(Theia 1.0.0 REQUIRED)
  message(STATUS "Using libtheia ${Theia_VERSION} in ${Theia_DIR}")
  add_definitions(-DHAS_LIBTHEIA="1")
  set(OPT_THEIA_TGT Theia::Theia)
else(WITH_LIBTHEIA)
  message(STATUS "Not using libtheia - licensing functions disabled")
  set(OPT_THEIA_TGT "")
endif(WITH_LIBTHEIA)

include_directories(
  ${LIBGVM_AGENT_CONTROLLER_INCLUDE_DIRS}
  ${LIBGVM_GMP_INCLUDE_DIRS}
  ${LIBGVM_OPENVASD_INCLUDE_DIRS}
  ${LIBGVM_BASE_INCLUDE_DIRS}
  ${LIBGVM_UTIL_INCLUDE_DIRS}
  ${LIBGVM_OSP_INCLUDE_DIRS}
  ${LIBBSD_INCLUDE_DIRS}
  ${GLIB_INCLUDE_DIRS}
)

add_library(gvm-pg-server SHARED manage_pg_server.c manage_utils.c)
set_target_properties(
  gvm-pg-server
  PROPERTIES SOVERSION "${CPACK_PACKAGE_VERSION_MAJOR}"
)
set_target_properties(
  gvm-pg-server
  PROPERTIES VERSION "${CPACK_PACKAGE_VERSION}"
)
include_directories(
  ${PostgreSQL_INCLUDE_DIRS}
  ${PostgreSQL_SERVER_INCLUDE_DIRS}
)

# Source lists
set(
  ALL_MANAGE_SRC
  manage.c
  manage_acl.c
  manage_alerts.c
  manage_configs.c
  manage_events.c
  manage_filter_utils.c
  manage_commands.c
  manage_get.c
  manage_http_scanner.c
  manage_license.c
  manage_openvas.c
  manage_osp.c
  manage_port_lists.c
  manage_preferences.c
  manage_resources.c
  manage_report_configs.c
  manage_report_formats.c
  manage_authentication.c
  manage_settings.c
  manage_tls_certificates.c
  manage_utils.c
  manage_migrators.c
  manage_pg.c
  manage_scan_handler.c
  manage_scan_queue.c
  manage_oci_image_targets.c
  manage_container_image_scanner.c
)

if(ENABLE_AGENTS)
  list(
    APPEND
    ALL_MANAGE_SRC
    manage_agent_common.c
    manage_agent_groups.c
    manage_agents.c
    manage_agent_installers.c
    manage_agent_control_scan_config.c
  )
endif()

set(
  ALL_MANAGE_SQL_SRC
  manage_sql.c
  manage_sql_copy.c
  manage_sql_alerts.c
  manage_sql_assets.c
  manage_sql_events.c
  manage_sql_filters.c
  manage_sql_nvts.c
  manage_sql_secinfo.c
  manage_sql_port_lists.c
  manage_sql_configs.c
  manage_sql_report_configs.c
  manage_sql_report_formats.c
  manage_sql_tickets.c
  manage_sql_tls_certificates.c
  manage_sql_nvts_osp.c
  manage_sql_nvts_openvasd.c
  manage_sql_nvts_common.c
  manage_sql_scan_queue.c
  manage_sql_oci_image_targets.c
)

if(ENABLE_AGENTS)
  list(
    APPEND
    ALL_MANAGE_SQL_SRC
    manage_sql_agent_groups.c
    manage_sql_agents.c
    manage_sql_agent_installers.c
  )
endif()

set(
  ALL_GMP_SRC
  gmp.c
  gmp_base.c
  gmp_configs.c
  gmp_delete.c
  gmp_get.c
  gmp_license.c
  gmp_logout.c
  gmp_port_lists.c
  gmp_report_configs.c
  gmp_report_formats.c
  gmp_tickets.c
  gmp_tls_certificates.c
  gmp_oci_image_targets.c
)

if(ENABLE_AGENTS)
  list(
    APPEND
    ALL_GMP_SRC
    gmp_agent_control_scan_agent_config.c
    gmp_agent_groups.c
    gmp_agents.c
    gmp_agent_installers.c
  )
endif()

set(ALL_SQL_SRC sql.c sql_pg.c)

set(
  ALL_MISC_SRC
  debug_utils.c
  gvmd.c
  gmpd.c
  ipc.c
  lsc_user.c
  lsc_crypt.c
  utils.c
)

## Object libraries

add_library(all-manage-obj OBJECT ${ALL_MANAGE_SRC})

add_library(all-manage-sql-obj OBJECT ${ALL_MANAGE_SQL_SRC})

add_library(all-gmp-obj OBJECT ${ALL_GMP_SRC})

add_library(all-sql-obj OBJECT ${ALL_SQL_SRC})

add_library(all-misc-obj OBJECT ${ALL_MISC_SRC})

## Program

if(ENABLE_COVERAGE)
  add_custom_target(
    coverage-html
    COMMAND
      gcovr --html-details ${COVERAGE_DIR}/coverage.html -r ${CMAKE_SOURCE_DIR}
      ${CMAKE_BINARY_DIR}
  )
  add_custom_target(
    coverage-xml
    COMMAND
      gcovr --xml ${COVERAGE_DIR}/coverage.xml -r ${CMAKE_SOURCE_DIR}
      ${CMAKE_BINARY_DIR}
  )
  add_custom_target(coverage DEPENDS coverage-xml coverage-html)
endif(ENABLE_COVERAGE)

add_custom_target(
  clean-coverage
  COMMAND find . -name *.gcda -delete -or -name *.gcno -delete
  COMMAND rm -f ${COVERAGE_DIR}/*
)

add_executable(
  gvmd
  main.c
  $<TARGET_OBJECTS:all-gmp-obj>
  $<TARGET_OBJECTS:all-manage-obj>
  $<TARGET_OBJECTS:all-manage-sql-obj>
  $<TARGET_OBJECTS:all-misc-obj>
  $<TARGET_OBJECTS:all-sql-obj>
)

target_link_libraries(
  gvmd
  m
  ${GNUTLS_LDFLAGS}
  ${GPGME_LDFLAGS}
  ${CMAKE_THREAD_LIBS_INIT}
  ${LINKER_HARDENING_FLAGS}
  ${LINKER_DEBUG_FLAGS}
  ${PostgreSQL_LIBRARIES}
  ${LIBBSD_LDFLAGS}
  ${CJSON_LDFLAGS}
  ${GLIB_LDFLAGS}
  ${GTHREAD_LDFLAGS}
  ${LIBGVM_AGENT_CONTROLLER_LDFLAGS}
  ${LIBGVM_BASE_LDFLAGS}
  ${LIBGVM_UTIL_LDFLAGS}
  ${LIBGVM_OSP_LDFLAGS}
  ${LIBGVM_OPENVASD_LDFLAGS}
  ${LIBGVM_GMP_LDFLAGS}
  ${LIBGVM_HTTP_LDFLAGS}
  ${LIBGVM_HTTP_SCANNER_LDFLAGS}
  ${LIBGVM_CONTAINER_IMAGE_SCANNER_LDFLAGS}
  ${LIBICAL_LDFLAGS}
  ${LINKER_HARDENING_FLAGS}
  ${OPT_THEIA_TGT}
)
target_link_libraries(
  gvm-pg-server
  ${LIBBSD_LDFLAGS}
  ${GLIB_LDFLAGS}
  ${GTHREAD_LDFLAGS}
  ${LIBGVM_AGENT_CONTROLLER_LDFLAGS}
  ${LIBGVM_BASE_LDFLAGS}
  ${LIBGVM_OPENVASD_LDFLAGS}
  ${LIBGVM_UTIL_LDFLAGS}
  ${LIBICAL_LDFLAGS}
  ${LINKER_HARDENING_FLAGS}
)

set_target_properties(gvmd PROPERTIES LINKER_LANGUAGE C)

macro(add_unit_test _baseName _objects _extraSource)
  string(REPLACE "-" "_" _testSource "${_baseName}")
  # manage_filter_utils.c
  set(_source "${_testSource}.c")
  # manage_filter_utils_tests.c
  set(_testSource "${_testSource}_tests.c")
  # manage-filter-utils-test
  set(_testName "${_baseName}-test")

  list(APPEND TEST_DEPENDENCIES ${_testName})
  set(TEST_TARGET_EXTRA_SRC ${_extraSource})
  list(REMOVE_ITEM TEST_TARGET_EXTRA_SRC ${_source})

  add_executable(
    ${_testName}
    EXCLUDE_FROM_ALL
    ${_testSource}
    ${_objects}
    ${TEST_TARGET_EXTRA_SRC}
  )
  add_test(${_testName} ${_testName})
  target_link_libraries(
    ${_testName}
    cgreen
    m
    ${GNUTLS_LDFLAGS}
    ${GPGME_LDFLAGS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${LINKER_HARDENING_FLAGS}
    ${LINKER_DEBUG_FLAGS}
    ${PostgreSQL_LIBRARIES}
    ${LIBBSD_LDFLAGS}
    ${CJSON_LDFLAGS}
    ${GLIB_LDFLAGS}
    ${GTHREAD_LDFLAGS}
    ${LIBGVM_AGENT_CONTROLLER_LDFLAGS}
    ${LIBGVM_BASE_LDFLAGS}
    ${LIBGVM_UTIL_LDFLAGS}
    ${LIBGVM_OSP_LDFLAGS}
    ${LIBGVM_OPENVASD_LDFLAGS}
    ${LIBGVM_GMP_LDFLAGS}
    ${LIBGVM_HTTP_LDFLAGS}
    ${LIBGVM_HTTP_SCANNER_LDFLAGS}
    ${LIBGVM_CONTAINER_IMAGE_SCANNER_LDFLAGS}
    ${LIBICAL_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
    ${OPT_THEIA_TGT}
  )
  set_target_properties(${_testName} PROPERTIES LINKER_LANGUAGE C)
  if(NOT CMAKE_BUILD_TYPE MATCHES "Release")
    target_compile_options(${_testName} PUBLIC ${C_FLAGS_DEBUG_GVMD})
  endif(NOT CMAKE_BUILD_TYPE MATCHES "Release")
endmacro()

set(
  ALL_OBJECTS
  $<TARGET_OBJECTS:all-manage-obj>
  $<TARGET_OBJECTS:all-manage-sql-obj>
  $<TARGET_OBJECTS:all-misc-obj>
  $<TARGET_OBJECTS:all-sql-obj>
)
add_unit_test(gmp-tickets "${ALL_OBJECTS}" "${ALL_GMP_SRC}")

set(
  ALL_OBJECTS
  $<TARGET_OBJECTS:all-gmp-obj>
  $<TARGET_OBJECTS:all-manage-sql-obj>
  $<TARGET_OBJECTS:all-misc-obj>
  $<TARGET_OBJECTS:all-sql-obj>
)
add_unit_test(manage "${ALL_OBJECTS}" "${ALL_MANAGE_SRC}")

if(ENABLE_AGENTS)
  set(
    ALL_OBJECTS
    $<TARGET_OBJECTS:all-gmp-obj>
    $<TARGET_OBJECTS:all-manage-sql-obj>
    $<TARGET_OBJECTS:all-misc-obj>
    $<TARGET_OBJECTS:all-sql-obj>
  )
  set(EXTRA_SRC ${ALL_MANAGE_SRC})
  list(REMOVE_ITEM EXTRA_SRC manage_sql_agent_installers.c)
  add_unit_test(
    manage-agent-installers
    "${ALL_OBJECTS}"
    "${EXTRA_SRC}"
  )
endif()

set(
  ALL_OBJECTS
  $<TARGET_OBJECTS:all-gmp-obj>
  $<TARGET_OBJECTS:all-manage-sql-obj>
  $<TARGET_OBJECTS:all-misc-obj>
  $<TARGET_OBJECTS:all-sql-obj>
)
add_unit_test(manage-filter-utils "${ALL_OBJECTS}" "${ALL_MANAGE_SRC}")

if(ENABLE_CONTAINER_SCANNING)
  set(
    ALL_OBJECTS
    $<TARGET_OBJECTS:all-gmp-obj>
    $<TARGET_OBJECTS:all-manage-sql-obj>
    $<TARGET_OBJECTS:all-misc-obj>
    $<TARGET_OBJECTS:all-sql-obj>
  )

=== debian/changelog ===
gvmd (26.5.0-1) unstable; urgency=medium

  * New upstream version 26.5.0
  * Refresh patches
  * Remove obsolete manpage greenbone-feed-sync
  * Update debian/watch to Version 5

 -- Sophie Brun <sophie@kali.org>  Fri, 31 Oct 2025 11:33:10 +0100

=== debian/control ===
Source: gvmd
Section: admin
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sophie Brun <sophie@kali.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               gnutls-bin,
               libgvm-dev (>= 22.23.0),
               libical-dev,
	       libbsd-dev,
	       libcjson-dev,
               libsqlite3-dev,
               pkgconf,
               postgresql-server-dev-all,
               xml-twig-tools,
               xmltoman,
               xsltproc
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.greenbone.net/
Vcs-Git: https://salsa.debian.org/pkg-security-team/gvmd.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/gvmd

Package: gvmd-common
Section: net
Architecture: all
Recommends: texlive-latex-extra
Depends: gnutls-bin,
         xsltproc,
         ${misc:Depends}
Multi-Arch: foreign
Suggests: gnupg, python3, python3-lxml, wget
Description: architecture independent files for Greenbone Vulnerability Manager
 The Greenbone Vulnerability Manager is the central management service between
 security scanners and the user clients.
 .
 It manages the storage of any vulnerability management configurations and of
 the scan results. Access to data, control commands and workflows is offered
 via the XML-based Greenbone Management Protocol (GMP). The primary scanner,
 openVAS Scanner is controlled directly via protocol OTP while any other remote
 scanner is coupled with the Open Scanner Protocol (OSP).
 .
 This package contains the common gvmd files shared by all architectures.

Package: gvmd
Section: net
Architecture: any
Depends: adduser,
         doc-base,
	 greenbone-feed-sync (>= 24.1.1),
         gvmd-common (= ${source:Version}),
	 notus-scanner (>= 22.4.0),
         ospd-openvas (>= 22.4.0),
         xml-twig-tools,
         ${misc:Depends},
         ${postgresql:Depends},
         ${shlibs:Depends}
Recommends: nsis, rpm
Breaks: openvas-administrator, openvas-manager
Replaces: libopenvas6, openvas-administrator, openvas-manager
Description: Manager Module of Greenbone Vulnerability Manager
 The Greenbone Vulnerability Manager is the central management service between
 security scanners and the user clients.
 .
 It manages the storage of any vulnerability management configurations and of
 the scan results. Access to data, control commands and workflows is offered
 via the XML-based Greenbone Management Protocol (GMP). The primary scanner,
 openVAS Scanner is controlled directly via protocol OTP while any other remote
 scanner is coupled with the Open Scanner Protocol (OSP).
 .
 This package contains the gvmd files architecture dependent.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
postgresqlversion=$(shell pkg-config --modversion libpq | cut -d '.' -f 1)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DPostgreSQL_TYPE_INCLUDE_DIR=/usr/include/postgresql -DDEFAULT_CONFIG_DIR=/etc/default -DLOGROTATE_DIR=/etc/logrotate.d -DGVM_DEFAULT_DROP_USER=_gvm -DINSTALL_OLD_SYNC_SCRIPTS=OFF -DSYSTEMD_SERVICE_DIR=/usr/lib/systemd/system -DGVM_LOG_DIR=/var/log/gvm

override_dh_auto_install:
	dh_auto_install
	rm -f debian/tmp/usr/share/gvm/gvm-lsc-rpm-creator.sh
# store the postgresql version used for compilation so that we can check
# that we have the same version in gvm-setup / gvm-check-setup during runtime
	mkdir -p debian/tmp/usr/share/gvmd
	pkg-config --modversion libpq > debian/tmp/usr/share/gvmd/postgresql-version

override_dh_auto_test:
	# disabled because make check fails

override_dh_missing:
	dh_missing --fail-missing

override_dh_fixperms-indep:
	find debian/gvmd-common/usr/share/gvm/gvmd -name alert -o -name generate | \
		xargs --no-run-if-empty chmod 755
	dh_fixperms

override_dh_installsystemd:
	dh_installsystemd --no-start

override_dh_installinit:
	dh_installinit --no-start

override_dh_gencontrol:
	dh_gencontrol -- -Vpostgresql:Depends="postgresql-$(postgresqlversion), postgresql-$(postgresqlversion)-pg-gvm"

=== debian/tests/control ===
Tests: test
Restrictions: allow-stderr
Depends: @, @builddeps@, libcgreen1-dev

=== debian/watch ===
Version: 5
Template: Github
Owner: greenbone
Project: gvmd

## gvmd 26.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,13 +19,13 @@
 
 message("-- Configuring Greenbone Vulnerability Manager...")
 
-project(gvm VERSION 26.5.0 LANGUAGES C)
+project(gvm VERSION 26.12.1 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)
 endif(POLICY CMP0005)
 
-set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
 
 include(FindPkgConfig)
 
@@ -250,10 +250,10 @@
 endif(NOT GVM_DEFAULT_DROP_USER)
 
 # Feature toggles
-if(NOT OPENVASD)
-  set(OPENVASD 0)
-endif(NOT OPENVASD)
-add_definitions(-DOPENVASD=${OPENVASD})
+if(NOT ENABLE_OPENVASD)
+  set(ENABLE_OPENVASD 0)
+endif(NOT ENABLE_OPENVASD)
+add_definitions(-DENABLE_OPENVASD=${ENABLE_OPENVASD})
 
 if(NOT ENABLE_AGENTS)
   set(ENABLE_AGENTS 0)
@@ -272,11 +272,6 @@
   set(ENDIF_NOT_ENABLE_AGENTS "")
 endif()
 
-if(NOT FEED_VT_METADATA)
-  set(FEED_VT_METADATA 0)
-endif(NOT FEED_VT_METADATA)
-add_definitions(-DFEED_VT_METADATA=${FEED_VT_METADATA})
-
 if(NOT ENABLE_CONTAINER_SCANNING)
   set(ENABLE_CONTAINER_SCANNING 0)
 endif(NOT ENABLE_CONTAINER_SCANNING)
@@ -290,13 +285,27 @@
   set(ENDIF_ENABLE_CONTAINER_SCANNNING "-->")
 endif()
 
-# HTTP scanner capability (used by OPENVASD / AGENTS / CONTAINER_SCANNING)
-if(OPENVASD OR ENABLE_AGENTS OR ENABLE_CONTAINER_SCANNING)
+# HTTP scanner capability (used by ENABLE_OPENVASD / AGENTS / CONTAINER_SCANNING)
+if(ENABLE_OPENVASD OR ENABLE_AGENTS OR ENABLE_CONTAINER_SCANNING)
   set(ENABLE_HTTP_SCANNER 1)
 else()
   set(ENABLE_HTTP_SCANNER 0)
 endif()
 add_definitions(-DENABLE_HTTP_SCANNER=${ENABLE_HTTP_SCANNER})
+
+# Credential stores
+if(NOT ENABLE_CREDENTIAL_STORES)
+  set(ENABLE_CREDENTIAL_STORES 0)
+endif(NOT ENABLE_CREDENTIAL_STORES)
+add_definitions(-DENABLE_CREDENTIAL_STORES=${ENABLE_CREDENTIAL_STORES})
+
+if(ENABLE_CREDENTIAL_STORES EQUAL 1)
+  set(IF_ENABLE_CREDENTIAL_STORES "")
+  set(ENDIF_ENABLE_CREDENTIAL_STORES "")
+elseif(ENABLE_CONTAINER_SCANNING EQUAL 0)
+  set(IF_ENABLE_CREDENTIAL_STORES "<!--")
+  set(ENDIF_ENABLE_CREDENTIAL_STORES "-->")
+endif()
 
 message("-- Install prefix: ${CMAKE_INSTALL_PREFIX}")
 message("-- Log file: ${GVMD_LOG_FILE}")
@@ -391,21 +400,3 @@
 
 install(
   FILES ${CMAKE_BINARY_DIR}/src/gvmd_log.conf
-  DESTINATION ${GVM_SYSCONF_DIR}
-)
-
-install(
-  FILES ${CMAKE_SOURCE_DIR}/src/pwpolicy.conf
-  DESTINATION ${GVM_SYSCONF_DIR}
-)
-
-# Schema formats.
-
-install(
-  FILES src/schema_formats/rnc.xsl
-  DESTINATION ${GVMD_DATA_DIR}/global_schema_formats/
-  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
-)
-
-install(
-  FILES src/schema_formats/rnc.xsl src/schema_formats/HTML/HTML.xsl

=== config/CMakeLists.txt ===
--- 
+++ 
@@ -36,3 +36,12 @@
   DESTINATION ${LOGROTATE_DIR}/
   RENAME gvmd
 )
+
+# Default gvmd.conf runtime flag configuration
+configure_file(gvmd.conf.in gvmd.conf @ONLY)
+
+install(
+  FILES ${CMAKE_CURRENT_BINARY_DIR}/gvmd.conf
+  DESTINATION ${GVM_SYSCONF_DIR}
+  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
+)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -27,38 +27,44 @@
 ## might occur.
 
 pkg_check_modules(CJSON REQUIRED libcjson>=1.7.14)
-pkg_check_modules(LIBGVM_BASE REQUIRED libgvm_base>=22.29)
-pkg_check_modules(LIBGVM_UTIL REQUIRED libgvm_util>=22.29)
-pkg_check_modules(LIBGVM_OSP REQUIRED libgvm_osp>=22.29)
-pkg_check_modules(LIBGVM_GMP REQUIRED libgvm_gmp>=22.29)
+pkg_check_modules(LIBGVM_BASE REQUIRED libgvm_base>=22.30)
+pkg_check_modules(LIBGVM_UTIL REQUIRED libgvm_util>=22.31)
+pkg_check_modules(LIBGVM_OSP REQUIRED libgvm_osp>=22.30)
+pkg_check_modules(LIBGVM_GMP REQUIRED libgvm_gmp>=22.30)
 
 if(ENABLE_HTTP_SCANNER)
-  pkg_check_modules(LIBGVM_HTTP REQUIRED libgvm_http>=22.29)
-  pkg_check_modules(LIBGVM_HTTP_SCANNER REQUIRED libgvm_http_scanner>=22.29)
+  pkg_check_modules(LIBGVM_HTTP REQUIRED libgvm_http>=22.30)
+  pkg_check_modules(LIBGVM_HTTP_SCANNER REQUIRED libgvm_http_scanner>=22.30)
 endif(ENABLE_HTTP_SCANNER)
-if(OPENVASD)
-  pkg_check_modules(LIBGVM_OPENVASD REQUIRED libgvm_openvasd>=22.29)
-else(OPENVASD)
-  message(STATUS "OPENVASD flag is not enabled")
-endif(OPENVASD)
+if(ENABLE_OPENVASD)
+  pkg_check_modules(LIBGVM_OPENVASD REQUIRED libgvm_openvasd>=22.30)
+else(ENABLE_OPENVASD)
+  message(STATUS "ENABLE_OPENVASD flag is not enabled")
+endif(ENABLE_OPENVASD)
 if(ENABLE_AGENTS)
   pkg_check_modules(
     LIBGVM_AGENT_CONTROLLER
     REQUIRED
-    libgvm_agent_controller>=22.29
+    libgvm_agent_controller>=22.30
   )
 else(ENABLE_AGENTS)
   message(STATUS "ENABLE_AGENTS flag is not enabled")
 endif(ENABLE_AGENTS)
+if(ENABLE_CREDENTIAL_STORES)
+  pkg_check_modules(LIBGVM_CYBERARK REQUIRED libgvm_cyberark>=22.30)
+else(ENABLE_CREDENTIAL_STORES)
+  message(STATUS "ENABLE_CREDENTIAL_STORES flag is not enabled")
+endif(ENABLE_CREDENTIAL_STORES)
 if(ENABLE_CONTAINER_SCANNING)
   pkg_check_modules(
     LIBGVM_CONTAINER_IMAGE_SCANNER
     REQUIRED
-    libgvm_container_image_scanner>=22.29
+    libgvm_container_image_scanner>=22.30
   )
 else(ENABLE_CONTAINER_SCANNING)
   message(STATUS "ENABLE_CONTAINER_SCANNING flag is not enabled")
 endif(ENABLE_CONTAINER_SCANNING)
+
 pkg_check_modules(GNUTLS REQUIRED gnutls>=3.2.15)
 pkg_check_modules(GLIB REQUIRED glib-2.0>=2.42)
 pkg_check_modules(LIBBSD REQUIRED libbsd)
@@ -166,11 +172,14 @@
   manage.c
   manage_acl.c
   manage_alerts.c
+  manage_credential_store_cyberark.c
+  manage_credential_stores.c
   manage_configs.c
   manage_events.c
   manage_filter_utils.c
   manage_commands.c
   manage_get.c
+  manage_groups.c
   manage_http_scanner.c
   manage_license.c
   manage_openvas.c
@@ -180,6 +189,7 @@
   manage_resources.c
   manage_report_configs.c
   manage_report_formats.c
+  manage_runtime_flags.c
   manage_authentication.c
   manage_settings.c
   manage_tls_certificates.c
@@ -194,8 +204,7 @@
 
 if(ENABLE_AGENTS)
   list(
-    APPEND
-    ALL_MANAGE_SRC
+    APPEND ALL_MANAGE_SRC
     manage_agent_common.c
     manage_agent_groups.c
     manage_agents.c
@@ -210,8 +219,10 @@
   manage_sql_copy.c
   manage_sql_alerts.c
   manage_sql_assets.c
+  manage_sql_credential_stores.c
   manage_sql_events.c
   manage_sql_filters.c
+  manage_sql_groups.c
   manage_sql_nvts.c
   manage_sql_secinfo.c
   manage_sql_port_lists.c
@@ -229,8 +240,7 @@
 
 if(ENABLE_AGENTS)
   list(
-    APPEND
-    ALL_MANAGE_SQL_SRC
+    APPEND ALL_MANAGE_SQL_SRC
     manage_sql_agent_groups.c
     manage_sql_agents.c
     manage_sql_agent_installers.c
@@ -256,13 +266,16 @@
 
 if(ENABLE_AGENTS)
   list(
-    APPEND
-    ALL_GMP_SRC
+    APPEND ALL_GMP_SRC
     gmp_agent_control_scan_agent_config.c
     gmp_agent_groups.c
     gmp_agents.c
     gmp_agent_installers.c
   )
+endif()
+
+if(ENABLE_CREDENTIAL_STORES)
+  list(APPEND ALL_GMP_SRC gmp_credential_stores.c)
 endif()
 
 set(ALL_SQL_SRC sql.c sql_pg.c)
@@ -289,6 +302,23 @@
 add_library(all-sql-obj OBJECT ${ALL_SQL_SRC})
 
 add_library(all-misc-obj OBJECT ${ALL_MISC_SRC})
+
+## Precommit-like checks
+
+if(NOT CMAKE_BUILD_TYPE MATCHES "Release")
+  add_custom_target(
+    check-whitespace
+    ALL
+    # once for output
+    COMMAND
+      grep -Hn "[ ]$$" *.c *.h | sed
+      "'s/^\\(.\\+:.\\+:\\)/\\1 error: trailing space: /'"
+    # again for exit code
+    COMMAND ! grep --quiet "[ ]$$" *.c *.h
+    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+    COMMENT "Checking whitespace..."
+  )
+endif(NOT CMAKE_BUILD_TYPE MATCHES "Release")
 
 ## Program
 
@@ -345,6 +375,7 @@
   ${LIBGVM_GMP_LDFLAGS}
   ${LIBGVM_HTTP_LDFLAGS}
   ${LIBGVM_HTTP_SCANNER_LDFLAGS}
+  ${LIBGVM_CYBERARK_LDFLAGS}
   ${LIBGVM_CONTAINER_IMAGE_SCANNER_LDFLAGS}
   ${LIBICAL_LDFLAGS}
   ${LINKER_HARDENING_FLAGS}
@@ -365,59 +396,26 @@
 
 set_target_properties(gvmd PROPERTIES LINKER_LANGUAGE C)
 
-macro(add_unit_test _baseName _objects _extraSource)
-  string(REPLACE "-" "_" _testSource "${_baseName}")
-  # manage_filter_utils.c
-  set(_source "${_testSource}.c")
-  # manage_filter_utils_tests.c
-  set(_testSource "${_testSource}_tests.c")
-  # manage-filter-utils-test
-  set(_testName "${_baseName}-test")
-
-  list(APPEND TEST_DEPENDENCIES ${_testName})
-  set(TEST_TARGET_EXTRA_SRC ${_extraSource})
-  list(REMOVE_ITEM TEST_TARGET_EXTRA_SRC ${_source})
-
-  add_executable(
-    ${_testName}
-    EXCLUDE_FROM_ALL
-    ${_testSource}
-    ${_objects}
-    ${TEST_TARGET_EXTRA_SRC}
-  )
-  add_test(${_testName} ${_testName})
-  target_link_libraries(
-    ${_testName}
-    cgreen
-    m
-    ${GNUTLS_LDFLAGS}
-    ${GPGME_LDFLAGS}
-    ${CMAKE_THREAD_LIBS_INIT}
-    ${LINKER_HARDENING_FLAGS}
-    ${LINKER_DEBUG_FLAGS}
-    ${PostgreSQL_LIBRARIES}
-    ${LIBBSD_LDFLAGS}
-    ${CJSON_LDFLAGS}
-    ${GLIB_LDFLAGS}
-    ${GTHREAD_LDFLAGS}
-    ${LIBGVM_AGENT_CONTROLLER_LDFLAGS}
-    ${LIBGVM_BASE_LDFLAGS}
-    ${LIBGVM_UTIL_LDFLAGS}
-    ${LIBGVM_OSP_LDFLAGS}
-    ${LIBGVM_OPENVASD_LDFLAGS}
-    ${LIBGVM_GMP_LDFLAGS}
-    ${LIBGVM_HTTP_LDFLAGS}
-    ${LIBGVM_HTTP_SCANNER_LDFLAGS}
-    ${LIBGVM_CONTAINER_IMAGE_SCANNER_LDFLAGS}
-    ${LIBICAL_LDFLAGS}
-    ${LINKER_HARDENING_FLAGS}
-    ${OPT_THEIA_TGT}
-  )
-  set_target_properties(${_testName} PROPERTIES LINKER_LANGUAGE C)
-  if(NOT CMAKE_BUILD_TYPE MATCHES "Release")
-    target_compile_options(${_testName} PUBLIC ${C_FLAGS_DEBUG_GVMD})
-  endif(NOT CMAKE_BUILD_TYPE MATCHES "Release")
-endmacro()
+include(${CMAKE_SOURCE_DIR}/cmake/add_unit_test.cmake)
+
+if(ENABLE_CREDENTIAL_STORES)
+  set(
+    ALL_OBJECTS
+    $<TARGET_OBJECTS:all-manage-obj>
+    $<TARGET_OBJECTS:all-manage-sql-obj>
+    $<TARGET_OBJECTS:all-misc-obj>
+  )
+  set(EXTRA_SRC ${ALL_GMP_SRC} ${ALL_SQL_SRC})
+  list(REMOVE_ITEM EXTRA_SRC gmp_credential_stores.c)
+  add_unit_test(gmp-credential-stores "${ALL_OBJECTS}" "${EXTRA_SRC}")
+  # Add linker wrap flag for acl_user_may to avoid multiple definition error
+  set_target_properties(
+    gmp-credential-stores-test
+    PROPERTIES
+      LINK_FLAGS
+        "-Wl,-wrap,acl_user_may,-wrap,find_resource_with_permission,-wrap,sql_begin_immediate,-wrap,sql_rollback,-wrap,find_resource_with_permission,-wrap,sql_string"
+  )
+endif()
 
 set(
   ALL_OBJECTS
@@ -447,11 +445,7 @@
   )
   set(EXTRA_SRC ${ALL_MANAGE_SRC})
   list(REMOVE_ITEM EXTRA_SRC manage_sql_agent_installers.c)
-  add_unit_test(
-    manage-agent-installers
-    "${ALL_OBJECTS}"
-    "${EXTRA_SRC}"
-  )
+  add_unit_test(manage-agent-installers "${ALL_OBJECTS}" "${EXTRA_SRC}")
 endif()
 
 set(
@@ -465,9 +459,3 @@
 
 if(ENABLE_CONTAINER_SCANNING)
   set(
-    ALL_OBJECTS
-    $<TARGET_OBJECTS:all-gmp-obj>
-    $<TARGET_OBJECTS:all-manage-sql-obj>
-    $<TARGET_OBJECTS:all-misc-obj>
-    $<TARGET_OBJECTS:all-sql-obj>
-  )

=== debian/changelog ===
gvmd (26.12.1-2) unstable; urgency=medium

  * Use default unix_socket /run/ospd/ospd.sock

 -- Sophie Brun <sophie@kali.org>  Fri, 19 Dec 2025 11:19:05 +0100

gvmd (26.12.1-1) unstable; urgency=medium

  * New upstream version 26.12.1
  * Refresh patches
  * Update minimal required version of libgvm
  * Refresh copyright
  * Add python3-lxml as dep of gvmd-common

 -- Sophie Brun <sophie@kali.org>  Thu, 04 Dec 2025 11:03:31 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                debhelper-compat (= 13),
                doxygen,
                gnutls-bin,
-               libgvm-dev (>= 22.23.0),
+               libgvm-dev (>= 22.31.0),
                libical-dev,
 	       libbsd-dev,
 	       libcjson-dev,
@@ -52,7 +52,7 @@
 	 greenbone-feed-sync (>= 24.1.1),
          gvmd-common (= ${source:Version}),
 	 notus-scanner (>= 22.4.0),
-         ospd-openvas (>= 22.4.0),
+         ospd-openvas (>= 22.9.1-2),
          xml-twig-tools,
          ${misc:Depends},
          ${postgresql:Depends},

## gvmd 26.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,25 +1,12 @@
 # Copyright (C) 2009-2022 Greenbone AG
 #
 # SPDX-License-Identifier: AGPL-3.0-or-later
-#
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero General Public License as
-# published by the Free Software Foundation, either version 3 of the
-# License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero General Public License for more details.
-#
-# You should have received a copy of the GNU Affero General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 cmake_minimum_required(VERSION 3.5)
 
 message("-- Configuring Greenbone Vulnerability Manager...")
 
-project(gvm VERSION 26.12.1 LANGUAGES C)
+project(gvm VERSION 26.13.0 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)
@@ -109,7 +96,7 @@
 
 ## Variables
 
-set(GVMD_DATABASE_VERSION 262)
+set(GVMD_DATABASE_VERSION 264)
 
 set(GVMD_SCAP_DATABASE_VERSION 22)
 
@@ -400,3 +387,29 @@
 
 install(
   FILES ${CMAKE_BINARY_DIR}/src/gvmd_log.conf
+  DESTINATION ${GVM_SYSCONF_DIR}
+)
+
+install(
+  FILES ${CMAKE_SOURCE_DIR}/src/pwpolicy.conf
+  DESTINATION ${GVM_SYSCONF_DIR}
+)
+
+# Schema formats.
+
+install(
+  FILES src/schema_formats/rnc.xsl
+  DESTINATION ${GVMD_DATA_DIR}/global_schema_formats/
+  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
+)
+
+install(
+  FILES src/schema_formats/rnc.xsl src/schema_formats/HTML/HTML.xsl
+  DESTINATION
+    ${GVMD_DATA_DIR}/global_schema_formats/02052818-dab6-11df-9be4-002264764cea/
+  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
+)
+
+install(
+  FILES src/schema_formats/HTML/generate
+  DESTINATION

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,19 +1,6 @@
 # Copyright (C) 2009-2022 Greenbone AG
 #
 # SPDX-License-Identifier: AGPL-3.0-or-later
-#
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero General Public License as
-# published by the Free Software Foundation, either version 3 of the
-# License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero General Public License for more details.
-#
-# You should have received a copy of the GNU Affero General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## Libraries
 
@@ -28,7 +15,7 @@
 
 pkg_check_modules(CJSON REQUIRED libcjson>=1.7.14)
 pkg_check_modules(LIBGVM_BASE REQUIRED libgvm_base>=22.30)
-pkg_check_modules(LIBGVM_UTIL REQUIRED libgvm_util>=22.31)
+pkg_check_modules(LIBGVM_UTIL REQUIRED libgvm_util>=22.34)
 pkg_check_modules(LIBGVM_OSP REQUIRED libgvm_osp>=22.30)
 pkg_check_modules(LIBGVM_GMP REQUIRED libgvm_gmp>=22.30)
 
@@ -189,6 +176,7 @@
   manage_resources.c
   manage_report_configs.c
   manage_report_formats.c
+  manage_roles.c
   manage_runtime_flags.c
   manage_authentication.c
   manage_settings.c
@@ -229,6 +217,7 @@
   manage_sql_configs.c
   manage_sql_report_configs.c
   manage_sql_report_formats.c
+  manage_sql_roles.c
   manage_sql_tickets.c
   manage_sql_tls_certificates.c
   manage_sql_nvts_osp.c
@@ -459,3 +448,26 @@
 
 if(ENABLE_CONTAINER_SCANNING)
   set(
+    ALL_OBJECTS
+    $<TARGET_OBJECTS:all-gmp-obj>
+    $<TARGET_OBJECTS:all-manage-sql-obj>
+    $<TARGET_OBJECTS:all-misc-obj>
+    $<TARGET_OBJECTS:all-sql-obj>
+  )
+  add_unit_test(manage-oci-image-targets "${ALL_OBJECTS}" "${ALL_MANAGE_SRC}")
+endif()
+
+set(
+  ALL_OBJECTS
+  $<TARGET_OBJECTS:all-gmp-obj>
+  $<TARGET_OBJECTS:all-manage-obj>
+  $<TARGET_OBJECTS:all-misc-obj>
+  $<TARGET_OBJECTS:all-sql-obj>
+)
+add_unit_test(manage-sql "${ALL_OBJECTS}" "${ALL_MANAGE_SQL_SRC}")
+
+set(
+  ALL_OBJECTS
+  $<TARGET_OBJECTS:all-gmp-obj>
+  $<TARGET_OBJECTS:all-manage-sql-obj>
+  $<TARGET_OBJECTS:all-misc-obj>

=== debian/changelog ===
gvmd (26.13.0-1) unstable; urgency=medium

  * New upstream version 26.13.0
  * Update minimal required version
  * Update debian/copyright

 -- Sophie Brun <sophie@kali.org>  Thu, 08 Jan 2026 11:06:08 +0100

## gvmd 26.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 message("-- Configuring Greenbone Vulnerability Manager...")
 
-project(gvm VERSION 26.13.0 LANGUAGES C)
+project(gvm VERSION 26.14.0 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)
@@ -96,7 +96,7 @@
 
 ## Variables
 
-set(GVMD_DATABASE_VERSION 264)
+set(GVMD_DATABASE_VERSION 265)
 
 set(GVMD_SCAP_DATABASE_VERSION 22)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -188,6 +188,7 @@
   manage_scan_queue.c
   manage_oci_image_targets.c
   manage_container_image_scanner.c
+  manage_users.c
 )
 
 if(ENABLE_AGENTS)
@@ -220,6 +221,7 @@
   manage_sql_roles.c
   manage_sql_tickets.c
   manage_sql_tls_certificates.c
+  manage_sql_users.c
   manage_sql_nvts_osp.c
   manage_sql_nvts_openvasd.c
   manage_sql_nvts_common.c
@@ -470,4 +472,3 @@
   ALL_OBJECTS
   $<TARGET_OBJECTS:all-gmp-obj>
   $<TARGET_OBJECTS:all-manage-sql-obj>
-  $<TARGET_OBJECTS:all-misc-obj>

=== debian/changelog ===
gvmd (26.14.0-1) unstable; urgency=medium

  * New upstream version 26.14.0
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 22 Jan 2026 17:04:17 +0100
